#! /usr/bin/awk -f
BEGIN {
  if (ITB=="") {
	ITB="/var/spool/quark/info/net/ITB";
  }
  ignore=0;
  while ((getline line <ITB) > 0) 
	{
      gsub(/
/,"",line);
	  if (line ~ /^\*/) {
		box=tolower(entumlauten(substr(line,2)));
		boxen[box]="x";
		baum[box,"zahl"]=0;
		baum[box,"up"]="";
		baum[box,"sum"]=0;
	  }
	  if (line ~ /^-/) {
		baum[box,"up"]=tolower(entumlauten(substr(line,2)));
	  }
	}
  close(ITB)
}

function prt(ebene,first,box, i, c) {
  if (ebene>0) {
    if (first==0){
	  printf("%-8.8s","");
	  for(c=0;c<ebene-1;c++) {
		printf(" %s %8.8s","    ","");
		#                   -//-
	  }
	}
	if (baum[box,"sum"]==0) {
	  printf(" -//- ");
	} else {
	  if (baum[box,"sum"]<100) {
		c=baum[box,"sum"];
		if (c<10)
		  c="0" c;
	  } else if (baum[box,"sum"] <1000) {
		c=int(baum[box,"sum"]/100);
		c=c "H";
	  } else {
		c=int(baum[box,"sum"]/1000);
		c=c "K";
	  }
	  printf(" -%s- ",c);
	}
  }
  printf("%-8.8s",toupper(box));
  c=0;
  first=1;
  for (i in boxen) {
	if (baum[i,"up"]==box) {
	  c++;
	  prt(ebene+1,first,i);
	  first=0;
	}
  }
  if (c==0)
	print ""
}

function entumlauten(str) {
  gsub(//,"ue",str);
  gsub(//,"Ue",str);
  gsub(//,"oe",str);
  gsub(//,"Oe",str);
  gsub(//,"ae",str);
  gsub(//,"Ae",str);
  gsub(//,"ss",str);
  return str;
}
# CR weg.
{  gsub(/
/,"",$0); }
# lange IDs abfangen 
/^#/ {
  if (box>"") {
	baum[box,"zahl"]++;
  }
  old=$0;
  if (! $0 ~ /@/) {
	ignore=1;
	next;
  }
  box="";
  foreign=0;
  ignore=0;
  if ($0 ~ /@.*maus.de/) {
	gsub(/^.*@/,"",$0);
	gsub(/\..*$/,"",$0);
	box=tolower($0);
  } else if ($0 ~ /@.*\./) {
	foreign=1;
  } else {
	gsub(/^.*@/,"",$0);
	box=entumlauten(tolower($0));
  }
  next;
}
ignore!=0 { next }
/^Y/ && foreign==1 {
  old=$0
  gsub(/^.*@/,"",$0);
  gsub(/^[ \t]*/,"",$0);
  gsub(/[ \t]*$/,"",$0);
  box=entumlauten(tolower($0));
}
END{
  baeume=0;
  if (box>"") {
	baum[box,"zahl"]++;
  }
  # gesamtmenge Nachrichten erhhen
  for (i in boxen) {
	baum[i,"sum"]+=baum[i,"zahl"];
	b=baum[i,"up"];
	while (b>"") {
	  baum[b,"sum"]+=baum[i,"zahl"];
	  b=baum[b,"up"];
	}
  }
  for (i in boxen) {
	if (baum[i,"up"]=="") {
	  baeume++;
	  if (baeume==1) {
		printf("Netzbaum (insgesamt %d Nachrichten)\n",baum[i,"sum"]);
	  } else {
		printf("Netzbaum %d (insgesamt %d Nachrichten)\n",baeume, baum[i,"sum"]);
	  }
	  prt(0,1,i);
	}
  }
  if (baeume>1) {
	print "Irgendwo wurde ein .cnf beschdigt"
  }
  print ""
  print "Statistik nach Boxen"
  printf("%-8.8s %8.8s %8.8s\n", "box", "selbst", "Summe");
  for (i in boxen) {
	printf("%-8.8s %8d %8s\n", toupper(i), baum[i,"zahl"],baum[i,"sum"]);
  }

}
