/* domains.h: domain part handling for mauscon */
/*
    Copyright (C) 1994 1995 1996 1997 Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@ohse.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
*/
#ifndef DOMAINS_H
#define DOMAINS_H

typedef struct box_t
{
	char *kuerzel;
	char *vglkuerzel; /* entumlautet */
	char *primdomain;
	char *orga;
	mc_list_t *secdomain;
	struct box_t *next;
} box_t;

typedef struct fidodomain_t
{
	int zone;
	char *internet_domain;
	char *fido_domain1;
	char *fido_domain2;
	struct fidodomain_t *next;
} fidodomain_t;

BOOLEAN dom_init(void);
box_t * dom_find_boxkuerzel(const char *kuerzel);
box_t * dom_find_domain(const char *domain);

fidodomain_t *fido_find_zone(int zone);
fidodomain_t *fido_find_idomain(const char *domain);
fidodomain_t *fido_find_fdomain(const char *domain);

#endif
