/* MausConnect: Nachrichtenformatskonverter fuer das MausNet
   Copyright (C) 1992 1993 1994 1995 Michael Kraehe, Uwe Ohse

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   lib.c: Allgemeine Hilfsfunktionen.
*/

#include "mausconsys.h"

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <ctype.h>
#include <fnmatch.h>

#include "mauscon.h"
#include "uostr.h"

BOOLEAN
is_allowed (const char *sender)
{
	char *lcsender;
	char *p;
	mc_list_t *akt;
	size_t l=strlen(sender);
	static uostr_t lcbuf=UOSTR_INIT; /* a memory buffer */
	uostr_xneed(&lcbuf,l+1);
	lcsender=lcbuf.data;

	for (p=lcsender; *sender; sender++)
		*p++=tolower(*sender);
	*p='\0';

	if (0==strhalfcasecmp(opts.mailuserdomain,lcsender))
		return TRUE;

	akt=opts.allowed;
	while (akt && akt->data)
	{
		/* naechster Versuch */
#ifndef FNM_CASEFOLD
		char buf[1024];
		if (strlen(akt->data)>=sizeof(buf)-1) {
			/* hoffentlich schreibt niemand soetwas in die Configdateien */
			fprintf(stderr,"overlong 'allowed' string in config file: %s\n",akt->data);
			syslog(LOG_ERR,"overlong 'allowed' string in config file");
			exit(1);
		}
		strcpy(buf,akt->data);
		strlwr(buf);
		if (!fnmatch (akt->data, lcsender, 0))
#else
		if (!fnmatch (akt->data, lcsender, FNM_CASEFOLD))
#endif
			return TRUE;
		akt=akt->next;
	}
	return FALSE;
}

