/*
    Copyright (C) 1994 1995 1996 1997 Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@ohse.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
*/
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "mausconlib.h"

char *
rfc_getword (char *rpos, char **nextpos)
{
	char *neu;
	char *wpos;
	char *p;
	char * const start=rpos;

	if (!rpos) {
		if (nextpos) *nextpos=0;
		return 0;
	}

	neu = (char *)malloc (strlen (rpos) + 1);
	if (!neu)
		return NULL;
	wpos = neu;

   /* Skip leading white space */
	while (isspace (*rpos))
		rpos++;

	while (*rpos && *rpos != ';')
	{
		switch (*rpos)
		{
		case '"':				/* quoted string */
			if (rpos==start)
			{
				for (rpos++; *rpos != '"' && *rpos; rpos++)
				{
					if (*rpos == '\\')
					{
						rpos++;
						*wpos++ = *rpos;
						if (!*rpos)
							break;
						rpos++;
					}
					else
						*wpos++ = *rpos;
				}
				if (*rpos)
					rpos++;
			}
			else
				*wpos++=*rpos++;
			break;
		case '(':				/* comment - weg damit */
			for (rpos++; *rpos != ')' && *rpos; rpos++)
			{
				if (*rpos == '\\')
				{
					rpos++;
					if (!*rpos)
						break;
				}
			}
			if (*rpos)
				rpos++;
			break;
		case '[':				/* domain literal - obsolet, aber wer wei ... */
			*wpos++ = *rpos;
			for (rpos++; *rpos != ']' && *rpos; rpos++)
			{
				if (*rpos == '\\')
				{
					rpos++;
					*wpos++ = *rpos;
					if (!*rpos)
						break;
					rpos++;
				}
				else
					*wpos++ = *rpos;
			}
			if (*rpos)
				rpos++;
			break;
		default:
			*wpos++ = *rpos;
			if (isspace (*rpos))
			{
				while (isspace (*rpos))
					rpos++;
			}
			else
				rpos++;
			break;
		}
	}
	*wpos = 0;
	if (nextpos)
	{
		if (*rpos == ';')
			*nextpos = rpos + 1;
		else
			*nextpos = NULL;
	}

	p = strdup (neu);
	free (neu);
	return p;
}

