/* 
   Copyright (C) 1999 Uwe Ohse

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <ctype.h>
#include "casefuncs.h"

int 
strnhalfcasecmp(const char *uplow, const char *low, size_t n)
{
	const unsigned char *p1 = (const unsigned char *) uplow;
	const unsigned char *p2 = (const unsigned char *) low;
	int ret;
	unsigned char c1;

	if (p1 == p2)
		return 0;

	for (; n--; p1++, p2++) 
	{
		c1=tolower(*p1);
		ret=(c1 - *p2);
		if (ret) 
			return ret;
		if (c1 == '\0') break;
	}
	return (0);

}
