/*
    Copyright (C) 1994 1995 1996 1997 Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@ohse.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
*/
#include "config.h"

#include <stdlib.h>

#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#ifdef STDC_HEADERS
#  include <stddef.h>
#endif
#include <errno.h>
#include "xwrite.h"

/*
 *  Keep writing until everything has been written or we get an error.
 */
ssize_t
xwrite(int fd, const void *data, size_t i)
{
	int        c;
	size_t len=i;
	const char *p=(const char *)data;

	for ( ; i; p += c, i -= c)
	{
		c = write(fd, p, (size_t) i);
#ifdef ERRNO
		if (c == 0 || (c<0 && errno!=EINTR))
#else
		if (c <= 0)
#endif
			return (size_t) -1;
	}
	return len;
}
